-- Script for allchars support (MP-side)

-- Set up the allchars variable
CV_RegisterVar({
	name = "allchars",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = {On = 1},
})

-- Switch to the exact same skin you already are
local function sameSkinSwitch(p)
	if not p and p.valid then return end
	if p.mo then
		local currentskin = skins[p.mo.skin]
		R_SetPlayerSkin(p, #currentskin)
	end
end

-- Turn sa2abilities on
local function sa2AbilitiesOn(p)
	CONS_Printf(p, "sa2abilities set to On")
	sameSkinSwitch(p)
	p.sa2noabilities = 0
end

-- Turn sa2abilities off
local function sa2AbilitiesOff(p)
	CONS_Printf(p, "sa2abilities set to Off")
	sameSkinSwitch(p)
	p.sa2noabilities = 1
end

-- Set up the noabilities command
local function sa2Abilities(p, val)
	if not (p and p.valid) then return end
	if val == nil then
		if p.sa2noabilities then
			CONS_Printf(p, "\"sa2abilities\" is \"Off\" default is \"Off\"")
		else
			CONS_Printf(p, "\"sa2abilities\" is \"On\" default is \"Off\"")
		end
	else
		if string.lower(val) == "on" or string.lower(val) == "yes"
		or string.lower(val) == "true" or val == "1" then
			sa2AbilitiesOn(p)
		elseif string.lower(val) == "off" or string.lower(val) == "no"
		or string.lower(val) == "false" or val == "0" then
			sa2AbilitiesOff(p)
		else
			CONS_Printf(p, "\"" .. val .. "\" is not a possible value for \"sa2abilities\"")
		end
	end
end

-- I'm making this a fake variable command because for SOME fucking reason
-- Making it a real variable sends the player into desync hell
COM_AddCommand("sa2abilities", sa2Abilities)

-- You can also toggle noabilities by pressing Fire and Fire Normal at the same time
local function naFireDown(p)
	if not (p and p.valid) then return end -- Valid player?
	if p.cmd.buttons & BT_ATTACK then p.nafire1 = $ + 1 else p.nafire1 = 0 end
	if p.cmd.buttons & BT_FIRENORMAL then p.nafire2 = $ + 1 else p.nafire2 = 0 end
	if p.nafire1 >= 1 and p.nafire1 <= 3 and p.nafire2 >= 1 and p.nafire2 <= 3 then
		p.nafire1, p.nafire2 = 4, 4
		if p.sa2noabilities then
			sa2AbilitiesOn(p)
		else
			sa2AbilitiesOff(p)
		end
	end
	-- Also default sa2abilities to Off in the multiplayer version
	if p.sa2noabilities == nil then
		p.sa2noabilities = true
		sameSkinSwitch(p)
	end
end

addHook("PlayerThink", naFireDown)